//
//  Setupsimulation.m
//  Core3D-Editor
//
//  Created by Julian Mayer on 10.06.09.
//  Copyright 2009 A. Julian Mayer. All rights reserved.
//

#import "Setupsimulation.h"
#import "FireParticlesystem.h"
#import "SphereParticlesystem.h"

@implementation Setupsimulation

- (id)init
{
	if ((self = [super init]))
	{

		Light *light = [[Light alloc] init];
		[light setPosition:vector3f(0, 3, 0)];

		RenderPass *rp = [[RenderPass alloc] initWithFrame:CGRectMake(0, 0, [scene bounds].width, [scene bounds].height) andAutoresizingMask:kCALayerWidthSizable | kCALayerHeightSizable];
		[[rp camera] setAxisConfiguration:kXYZRotation];
		[[rp camera] setPosition:vector3f(0, 20, 0)];
		[[rp camera] setRotation:vector3f(-90, 0, 0)];
        

		[[rp lights] addObject:light];
		  

       ShaderNode *s = [[ShaderNode alloc] initWithShader:[scene colorOnlyShader]];
		SphereParticlesystem *plasmaBolt = [[SphereParticlesystem alloc] initWithParticleCount:4096 andTextureNamed:@"particle"]; 
        [plasmaBolt setSize:1.8];
		SphereParticlesystem *plasmaBolt2 = [[SphereParticlesystem alloc] initWithParticleCount:4096 andTextureNamed:@"particle"]; 
        [plasmaBolt2 setSize:1.8];
        [plasmaBolt setPosition:vector3f(3, 0, 0)];
        [plasmaBolt2 setPosition:vector3f(-3, 0, 0)];

		Mesh *e1 = [[Mesh alloc] initWithOctreeNamed:@"damageSphere"];
		Mesh *e2 = [[Mesh alloc] initWithOctreeNamed:@"bombSphere"];
        [e1 setPosition:vector3f(10, 0, 0)];
        [e2 setPosition:vector3f(1, 18, 0)];
        [e2 setColor:vector4f(0.7, 0.2, 0.2, 1.0)];
		
		[self addAnimationWithDuration:999.0
							 animation:^(double delay){
								 [e1 setRotation:vector3f(delay * 100, 0, 0)];
								 [e2 setRotation:vector3f(0, delay * 100, 0)];
							 }
							completion:^{}];
		

		
		[[s children] addObject:e1];
        [[s children] addObject:e2];
             [[s children] addObject:plasmaBolt];
        [[s children] addObject:plasmaBolt2];
        
   [[rp objects] addObject:s];


		[rp setRenderTarget:[[[RenderTarget alloc] initWithWidthMultiplier:1.0 andHeightMultiplier:1.0] autorelease]];


		
		[scene setMainRenderPass:rp];
		
		[[scene renderpasses] addObject:rp];

	
		//globalSettings.disableVBLSync = YES;
		//globalSettings.disableVBLSync = YES;
		//globalSettings.disableVBLSync = YES;
		//globalSettings.disableVBLSync = YES;
		//globalSettings.disableVBLSync = YES;


	}
	return self;
}


#ifndef TARGET_OS_IPHONE
- (void)keyDown:(NSEvent *)theEvent
{
	unichar c = [[theEvent charactersIgnoringModifiers] characterAtIndex:0];
	
	if ((([theEvent modifierFlags] & NSDeviceIndependentModifierFlagsMask) == NSCommandKeyMask) && (c == 'e'))
	{
		[Editor loadEditor:self];
	}
}
#endif

@end
