#import "Core3D.h"


#ifdef APPSTORE_VALIDATERECEIPT
#import "validatereceipt.h"
#endif

#ifndef APPLICATIONCLASS
#define APPLICATIONCLASS NSApplication
#else
@interface APPLICATIONCLASS : NSApplication;
@end
#endif


/*
 not on shitlist anymore: NVIDIA GeForce GT 330 

 lightless 
 
 NVIDIA GeForce GT 120 
 NVIDIA GeForce GT 130 
 NVIDIA GeForce 320 
 NVIDIA GeForce 9600
 ATI Radeon HD 2600 
 ATI Radeon X1900 
 
 lightless + hwpcf + fsaa
 
 Intel HD Graphics 3000 
 ATI Radeon X1600 
 NVIDIA GeForce 7600
 NVIDIA GeForce 8600
 
 lightless + fsaa + hwpcf + texfiltering 
 
 ATI Radeon HD 2400
 NVIDIA GeForce 7300
 NVIDIA GeForce 9400 

 */
#if !defined(WIN32) && !defined(__linux__)
BOOL PreCheckOpenGL(void)
{
	BOOL hasOpenGL21 = FALSE;
	CGLPixelFormatAttribute attribs[] = {kCGLPFAAccelerated, (CGLPixelFormatAttribute)NULL};
	CGLPixelFormatObj pixelFormat = NULL;
	long numPixelFormats = 0;
	CGLContextObj myCGLContext = 0, curr_ctx = CGLGetCurrentContext ();
	CGLChoosePixelFormat(attribs, &pixelFormat, (GLint*)&numPixelFormats);
	if (pixelFormat)
	{
		CGLCreateContext(pixelFormat, NULL, &myCGLContext);
		CGLDestroyPixelFormat(pixelFormat);
		CGLSetCurrentContext(myCGLContext);

		if (myCGLContext)
		{
            
            GLint value;
            GLint nrend;
            CGLRendererInfoObj rend;
            CGLQueryRendererInfo(CGDisplayIDToOpenGLDisplayMask(kCGDirectMainDisplay), &rend, &nrend);
            CGLDescribeRenderer(rend, 0, kCGLRPMaxSamples, &value);
//            NSLog(@" max samples %i", value);
            globalInfo.maxMultiSamples = value;
            NSArray *version = [[NSString stringWithUTF8String:(const char *)glGetString(GL_VERSION)] componentsSeparatedByString:@"."];
            if (([[version objectAtIndex:0] intValue] == 2 && [[version objectAtIndex:1] intValue] >= 1) ||
                [[version objectAtIndex:0] intValue] > 2)
                hasOpenGL21 = TRUE;
            
			NSString *renderer = [NSString stringWithUTF8String:(const char *)glGetString(GL_RENDERER)];
            
            for (NSString *name in $array(@"NVIDIA GeForce GT 120", @"NVIDIA GeForce GT 130", @"NVIDIA GeForce 320", @"NVIDIA GeForce 9600",  @"ATI Radeon HD 2600", @"ATI Radeon X1900"))
                 if ([renderer hasPrefix:name])
                    globalInfo.gpuSuckynessClass = 1;

            for (NSString *name in $array(@"NVIDIA GeForce 7600", @"NVIDIA GeForce 8600", @"Intel HD Graphics 3000", @"ATI Radeon X1600"))
                if ([renderer hasPrefix:name])
                    globalInfo.gpuSuckynessClass = 2;
            
            for (NSString *name in $array(@"NVIDIA GeForce 7300", @"NVIDIA GeForce 9400", @"ATI Radeon HD 2400"))
                if ([renderer hasPrefix:name])
                    globalInfo.gpuSuckynessClass = 3;
            
            // what is the VRAM
            GLint vram = 0;
            CGLDescribeRenderer(rend, 0, kCGLRPVideoMemory, &vram); 
            globalInfo.VRAM = vram;
            CGLDestroyRendererInfo(rend);
		}
	}
	CGLDestroyContext(myCGLContext);
	CGLSetCurrentContext(curr_ctx);

	return hasOpenGL21;
}
#endif


int main(int argc, char *argv[])
{
#if !defined(WIN32) && !defined(__linux__)
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

#ifdef APPSTORE_VALIDATERECEIPT
	assert(!validateReceiptAtPath([[NSBundle mainBundle] pathForResource:@"addthis" ofType:@"html"]));
	if (!validateReceiptAtPath([[[NSBundle mainBundle] bundlePath] stringByAppendingPathComponent:@"Contents/_MASReceipt/receipt"]))
	{
		exit(173);
		return 173;
	}
#endif
    
    
	[APPLICATIONCLASS sharedApplication];

	if (!PreCheckOpenGL())
	{
		NSRunAlertPanel(@"Error", @"CoreBreach requires an OpenGL 2.1 compliant video card (Radeon HD 2400 / GeForce 7300 / HD Graphics 3000). Trying to play the game on your hardware may result in crashes or even freeze your Mac - continue at your own risk!", @"OK", nil, nil);
	}

	[NSBundle loadNibNamed:[[NSBundle mainBundle] objectForInfoDictionaryKey:@"NSMainNibFile"] owner:NSApp];
    
#if defined(SDL) && defined(TARGET_OS_MAC)
    [NSBundle loadNibNamed:@"Launcher" owner:NSApp];
#endif
    
	[pool release];
	[NSApp run];

    
#else
	return NSApplicationMain(argc,  (const char **) argv);
#endif
}


